From 517c1f61e2f372e7720f3cad97893e44e3e00f5d Mon Sep 17 00:00:00 2001
From: Ivan Richwalski <ivan@seppuku.net>
Date: Wed, 8 Nov 2017 01:32:44 -0600
Subject: [PATCH] 5914 pipe generates inodes with ino > 4G

---
 usr/src/uts/common/fs/fifofs/fifosubr.c | 8 ++++++--
 1 file changed, 6 insertions(+), 2 deletions(-)

diff --git a/usr/src/uts/common/fs/fifofs/fifosubr.c b/usr/src/uts/common/fs/fifofs/fifosubr.c
index 6e56000ffe..0a367e047c 100644
--- a/usr/src/uts/common/fs/fifofs/fifosubr.c
+++ b/usr/src/uts/common/fs/fifofs/fifosubr.c
@@ -22,6 +22,9 @@
 
 /*
  * Copyright (c) 1988, 2010, Oracle and/or its affiliates. All rights reserved.
+ *
+ * Copyright 2017 Ivan Richwalski <ivan@seppuku.net>
+ *
  */
 
 /*
@@ -552,12 +555,13 @@ makepipe(vnode_t **vpp1, vnode_t **vpp2)
 
 /*
  * Attempt to establish a unique pipe id.  Only un-named pipes use this
- * routine.
+ * routine. Use a 32-bit ino_t so any 32-bit processes that aren't large
+ * file aware can still stat() a pipe fd and not fail with EOVERFLOW.
  */
 ino_t
 fifogetid(void)
 {
-	static ino_t fifo_ino = 0;
+	static ino32_t fifo_ino = 0;
 	ino_t fino;
 
 	mutex_enter(&fino_lock);
-- 
2.14.2

